import { Agile } from './agile';
/**
 * Shared Agile Instance that is used when no Agile Instance was specified.
 */
declare let sharedAgileInstance: Agile;
export { sharedAgileInstance, sharedAgileInstance as shared };
/**
 * Assigns the specified Agile Instance as the shared Agile Instance.
 *
 * @param agileInstance - Agile Instance to become the new shared Agile Instance.
 */
export declare function assignSharedAgileInstance(agileInstance: Agile): void;
/**
 * Extracts an Instance of Agile from the specified Instance.
 * When no valid Agile Instance was found,
 * it returns the global bound Agile Instance or `undefined`.
 *
 * @internal
 * @param instance - Instance to extract the Agile Instance from.
 */
export declare function getAgileInstance(instance: any): Agile | undefined;
export interface CreateAgileSubInstanceInterface {
    /**
     * Instance of Agile the Instance belongs to.
     * @default sharedAgileInstance
     */
    agileInstance?: Agile;
}
