import { defineConfig } from '@agile-ts/utils';
import { EnhancedState } from '../state/state.enhanced.js';

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
const _Selector = class extends EnhancedState {
  constructor(collection, itemKey, config = {}) {
    config = defineConfig(config, {
      isPlaceholder: false
    });
    super(collection.agileInstance(), null, config);
    this.collection = () => collection;
    this._item = null;
    this._itemKey = !config.isPlaceholder && itemKey != null ? itemKey : null;
    this._key = config == null ? void 0 : config.key;
    this.isPlaceholder = true;
    if (this._itemKey != null)
      this.select(itemKey, { overwrite: true });
  }
  get itemKey() {
    return this._itemKey;
  }
  set itemKey(value) {
    this.select(value);
  }
  get item() {
    return this._item;
  }
  set item(value) {
    if (value == null ? void 0 : value._key)
      this.select(value._key);
  }
  select(itemKey, config = {}) {
    var _a, _b;
    config = defineConfig(config, {
      background: false,
      sideEffects: {
        enabled: true,
        exclude: []
      },
      force: false,
      overwrite: (_b = (_a = this._item) == null ? void 0 : _a.isPlaceholder) != null ? _b : false,
      storage: true
    });
    if ((!this.collection().isInstantiated || this.hasSelected(itemKey)) && !config.force)
      return this;
    this.unselect({ background: itemKey != null });
    if (itemKey == null)
      return this;
    const newItem = this.collection().getItemWithReference(itemKey);
    this._itemKey = itemKey;
    this._item = newItem;
    newItem.selectedBy.add(this._key);
    newItem.addSideEffect(_Selector.rebuildSelectorSideEffectKey, (instance, config2) => this.rebuildSelector(config2), { weight: 100 });
    this.addSideEffect(_Selector.rebuildItemSideEffectKey, (instance, config2) => {
      var _a2, _b2;
      if (!((_a2 = instance._item) == null ? void 0 : _a2.isPlaceholder))
        (_b2 = instance._item) == null ? void 0 : _b2.set(instance._value, __spreadValues(__spreadValues({}, config2), {
          sideEffects: {
            enabled: true,
            exclude: [_Selector.rebuildSelectorSideEffectKey]
          }
        }));
    }, { weight: 90 });
    this.rebuildSelector(config);
    return this;
  }
  reselect(config = {}) {
    if (this._itemKey != null && !this.hasSelected(this._itemKey) || config.force)
      this.select(this._itemKey, config);
    return this;
  }
  unselect(config = {}) {
    const item = this.collection().getItem(this._itemKey, {
      notExisting: true
    });
    if (item != null) {
      item.selectedBy.delete(this._key);
      item.removeSideEffect(_Selector.rebuildSelectorSideEffectKey);
      item.removeSideEffect(_Selector.rebuildItemSideEffectKey);
      if (item.isPlaceholder && this._itemKey != null)
        delete this.collection().data[this._itemKey];
    }
    this._item = null;
    this._itemKey = null;
    this.rebuildSelector(config);
    this.isPlaceholder = true;
    return this;
  }
  hasSelected(itemKey, correctlySelected = true) {
    if (correctlySelected) {
      return this._itemKey === itemKey && this._item != null && this._item.selectedBy.has(this._key);
    }
    return this._itemKey === itemKey;
  }
  rebuildSelector(config = {}) {
    if (this._item == null || this._item.isPlaceholder) {
      this.set(null, config);
      return this;
    }
    this.set(this._item._value, config);
    return this;
  }
};
let Selector = _Selector;
Selector.rebuildSelectorSideEffectKey = "rebuildSelector";
Selector.rebuildItemSideEffectKey = "rebuildItem";

export { Selector };
