import { defineConfig } from '@agile-ts/utils';
import { RuntimeJob } from '../runtime/runtime.job.js';

class StateRuntimeJob extends RuntimeJob {
  constructor(observer, config = {}) {
    super(observer, config);
    config = defineConfig(config, {
      background: false,
      sideEffects: {
        enabled: true,
        exclude: []
      },
      force: false,
      storage: true,
      overwrite: false,
      maxTriesToUpdate: 3,
      any: {}
    });
    this.config = {
      background: config.background,
      force: config.force,
      sideEffects: config.sideEffects,
      storage: config.storage,
      overwrite: config.overwrite,
      maxTriesToUpdate: config.maxTriesToUpdate,
      any: config.any
    };
  }
}

export { StateRuntimeJob };
